'*******************************************************************************
'  RS232 SETUP
'*******************************************************************************
'
'  Copyright bascom-forum.de (C) [2009]  [DON]
'  -> http://bascom-forum.de/index.php?topic=1781.new;topicseen#new
'  Software based on Code by Ben Zijlstra and Viktor Varga
'  Weiterentwickelt von
'    Huetti,
'    Michael
'    boeserkorn
'    mr_energy
'    HansHans
'    six1, Michael Kcher
'    dabuze                            datetime
'    framuel
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile

'*******************************************************************************
'  RS232 EERam-Datenupdate
'*******************************************************************************
Sub Php_rs232
Local Rs232_a As String * 4
Local Rs232_b As Byte
Local S As String * 50
Local I As Integer

     If Incoming_data <> "" Then
         Rs232_a = Mid(incoming_data , 1 , 4)
         Rs232_b = Len(incoming_data) - 4
         If Rs232_b > 0 Then
           Incoming_data = Mid(incoming_data , 5 , Rs232_b)
         End If
         Select Case Rs232_a
               Case "#50#" :
                              Print "Hello World Freesol: " ; Incoming_data


               'Send NETIO Setup's
               Case "{50}" :
                              Print "{50}" ; Str(my_b_ipaddr_l)       'Str(my_b_ipaddr(1)) ; "." ; Str(my_b_ipaddr(2)) ; "." ; Str(my_b_ipaddr(3)) ; "." ; Str(my_b_ipaddr(4))
                              Print "{51}" ; Str(my_b_subnetmask_l)       'Str(my_b_subnetmask(1)) ; "." ; Str(my_b_subnetmask(2)) ; "." ; Str(my_b_subnetmask(3)) ; "." ; Str(my_b_subnetmask(4))
                              Print "{52}" ; Hex(my_b_macaddr(1)) ; ":" ; Hex(my_b_macaddr(2)) ; ":" ; Hex(my_b_macaddr(3)) ; ":" ; Hex(my_b_macaddr(4)) ; ":" ; Hex(my_b_macaddr(5)) ; ":" ; Hex(my_b_macaddr(6))
                              Print "{53}" ; My_s12_hostname
                              Print "{54}" ; Str(my_b_defaultgateway_l)       'Str(my_b_defaultgateway(1)) ; "." ; Str(my_b_defaultgateway(2)) ; "." ; Str(my_b_defaultgateway(3)) ; "." ; Str(my_b_defaultgateway(4))
                             #if Include_dns = 1
                              Print "{55}" ; Str(dns_b_nameserver_l)       'Str(dns_b_nameserver(1)) ; "." ; Str(dns_b_nameserver(2)) ; "." ; Str(dns_b_nameserver(3)) ; "." ; Str(dns_b_nameserver(4))
                             #endif
                             #if Include_ntp > 0
                              Print "{56}" ; Str(ntp_b_server_l)       'Str(ntp_b_server(1)) ; "." ; Str(ntp_b_server(2)) ; "." ; Str(ntp_b_server(3)) ; "." ; Str(ntp_b_server(4))
                             #endif
                             #if Include_ntp = 0
                              Print "{56}-100"
                             #endif
                             #if Include_php_call
                              Print "{57}" ; Str(my_netio_addr)
                              Print "{58}" ; Str(my_php_server_ip_addr_l)       'Str(my_php_server_ip_addr(1)) ; "." ; Str(my_php_server_ip_addr(2)) ; "." ; Str(my_php_server_ip_addr(3)) ; "." ; Str(my_php_server_ip_addr(4))
                              Print "{59}" ; My_php_script
                              Print "{60}" ; Php_base_second
                             #endif
                             #if Netio_mode = 90
                              Smtp_s31_meine_email_adresse = Ee_s31_meine_email_adresse
                              S = Left(smtp_s31_meine_email_adresse , 18)
                              Print "{71}" ; S
                              S = Mid(smtp_s31_meine_email_adresse , 19 , 13)
                              Print "{72}" ; S

                              Smtp_s31_empfaenger_mail_adresse = Ee_s31_empfaenger_email_adresse
                              S = Left(smtp_s31_empfaenger_mail_adresse , 18)
                              Print "{73}" ; S
                              S = Mid(smtp_s31_empfaenger_mail_adresse , 19 , 13)
                              Print "{74}" ; S

                              Smtp_s47_benutzerkennung = Ee_s47_benutzerkennung       '47
                              I = Len(smtp_s47_benutzerkennung)
                              I = I - 2
                              S = Left(smtp_s47_benutzerkennung , I)
                              Print "{75}" ; S
                              Smtp_s31_passwort = Ee_s31_passwort
                              I = Len(smtp_s31_passwort)
                              I = I - 2
                              S = Left(smtp_s31_passwort , I)
                              Print "{76}" ; S
                              Fs_anlagenleistung = Ee_fs_anlagenleistung
                              Print "{77}" ; Fs_anlagenleistung
                              Fs_pulszahlges = Ee_fs_pulszahlges
                              Print "{78}" ; Fs_pulszahlges
                              Fs_pulsfaktor = Ee_fs_pulsfaktor
                              Print "{81}" ; Fs_pulsfaktor
                             #endif
               'write IP
               Case "{00}" :
                              Call Spliter( ".")
                              My_b_ipaddr(1) = Val(rs232_c(1)) : My_b_ipaddr(2) = Val(rs232_c(2)) : My_b_ipaddr(3) = Val(rs232_c(3)) : My_b_ipaddr(4) = Val(rs232_c(4))
                              Ee_b_ipaddr(1) = My_b_ipaddr(1) : Ee_b_ipaddr(2) = My_b_ipaddr(2) : Ee_b_ipaddr(3) = My_b_ipaddr(3) : Ee_b_ipaddr(4) = My_b_ipaddr(4)
               'write Subnet
               Case "{01}" :
                              Call Spliter( ".")
                              My_b_subnetmask(1) = Val(rs232_c(1)) : My_b_subnetmask(2) = Val(rs232_c(2)) : My_b_subnetmask(3) = Val(rs232_c(3)) : My_b_subnetmask(4) = Val(rs232_c(4))
                              Ee_b_subnetmask(1) = My_b_subnetmask(1) : Ee_b_subnetmask(2) = My_b_subnetmask(2) : Ee_b_subnetmask(3) = My_b_subnetmask(3) : Ee_b_subnetmask(4) = My_b_subnetmask(4)
               'write MAC
               Case "{02}" :
                              Call Spliter( ":")
                              My_b_macaddr(1) = Hexval(rs232_c(1)) : My_b_macaddr(2) = Hexval(rs232_c(2)) : My_b_macaddr(3) = Hexval(rs232_c(3)) : My_b_macaddr(4) = Hexval(rs232_c(4)) : My_b_macaddr(5) = Hexval(rs232_c(5)) : My_b_macaddr(6) = Hexval(rs232_c(6))
                              Ee_b_macaddr(1) = My_b_macaddr(1) : Ee_b_macaddr(2) = My_b_macaddr(2) : Ee_b_macaddr(3) = My_b_macaddr(3) : Ee_b_macaddr(4) = My_b_macaddr(4) : Ee_b_macaddr(5) = My_b_macaddr(5) : Ee_b_macaddr(6) = My_b_macaddr(6)
               'write Hostname
               Case "{03}" :
                             My_s12_hostname = Incoming_data
                             Ee_s12_hostname = My_s12_hostname

               'write Gateway
               Case "{04}" :
                              Call Spliter( ".")
                              My_b_defaultgateway(1) = Val(rs232_c(1)) : My_b_defaultgateway(2) = Val(rs232_c(2)) : My_b_defaultgateway(3) = Val(rs232_c(3)) : My_b_defaultgateway(4) = Val(rs232_c(4))
                              Ee_b_defaultgateway(1) = My_b_defaultgateway(1) : Ee_b_defaultgateway(2) = My_b_defaultgateway(2) : Ee_b_defaultgateway(3) = My_b_defaultgateway(3) : Ee_b_defaultgateway(4) = My_b_defaultgateway(4)

               'write DNS
               Case "{05}" :
                              #if Include_dns = 1
                              Call Spliter( ".")
                              Dns_b_nameserver(1) = Val(rs232_c(1)) : Dns_b_nameserver(2) = Val(rs232_c(2)) : Dns_b_nameserver(3) = Val(rs232_c(3)) : Dns_b_nameserver(4) = Val(rs232_c(4))
                              Ee_b_nameserver(1) = Dns_b_nameserver(1) : Ee_b_nameserver(2) = Dns_b_nameserver(2) : Ee_b_nameserver(3) = Dns_b_nameserver(3) : Ee_b_nameserver(4) = Dns_b_nameserver(4)
                              #endif

               #if Include_ntp = 1
               'write NTP
               Case "{06}" :
                              Call Spliter( ".")
                              Ntp_b_server(1) = Val(rs232_c(1)) : Ntp_b_server(2) = Val(rs232_c(2)) : Ntp_b_server(3) = Val(rs232_c(3)) : Ntp_b_server(4) = Val(rs232_c(4))
                              Ee_b_ntpserver(1) = Ntp_b_server(1) : Ee_b_ntpserver(2) = Ntp_b_server(2) : Ee_b_ntpserver(3) = Ntp_b_server(3) : Ee_b_ntpserver(4) = Ntp_b_server(4)
               #endif

               #if Include_php_call
               Case "{07}" :
                              My_netio_addr = Val(incoming_data)
                              Ee_netio_addr = My_netio_addr
               'schreibe PHP Server Adress
               Case "{08}" :
                               Call Spliter( ".")
                               My_php_server_ip_addr(1) = Val(rs232_c(1)) : My_php_server_ip_addr(2) = Val(rs232_c(2)) : My_php_server_ip_addr(3) = Val(rs232_c(3)) : My_php_server_ip_addr(4) = Val(rs232_c(4))
                               Ee_php_server_ip_addr(1) = My_php_server_ip_addr(1) : Ee_php_server_ip_addr(2) = My_php_server_ip_addr(2) : Ee_php_server_ip_addr(3) = My_php_server_ip_addr(3) : Ee_php_server_ip_addr(4) = My_php_server_ip_addr(4)
               'schreibe PHP Script Name
               Case "{09}" :
                               My_php_script = Incoming_data
                               Ee_php_script = My_php_script
               Case "{10}" :
                               Php_base_second = Val(incoming_data)
                               Ee_php_time = Php_base_second
               'Ausfhrungszeit frPHP Script in Sekunden
               #endif
               'schreibe Zeichen 1-18 von Ee_s31_meine_email_adresse, Emailadresse muss von < > eingerahmt sein
               Case "{21}" :
                             S = Incoming_data
                             Smtp_s31_meine_email_adresse = Mid(smtp_s31_meine_email_adresse , 19 , 13)
                             Smtp_s31_meine_email_adresse = S + Smtp_s31_meine_email_adresse
                             Ee_s31_meine_email_adresse = Smtp_s31_meine_email_adresse
               'schreibe Zeichen 19-31 von Ee_s31_meine_email_adresse, Emailadresse muss von < > eingerahmt sein
               Case "{22}" :
                             S = Incoming_data
                             Smtp_s31_meine_email_adresse = Left(smtp_s31_meine_email_adresse , 18)
                             Smtp_s31_meine_email_adresse = Smtp_s31_meine_email_adresse + S
                             Ee_s31_meine_email_adresse = Smtp_s31_meine_email_adresse
               'schreibe Zeichen 1-18 von Ee_s31_empfaenger_email_adresse, Emailadresse muss von < > eingerahmt sein
               Case "{23}" :
                             S = Incoming_data
                             Smtp_s31_empfaenger_mail_adresse = Mid(smtp_s31_empfaenger_mail_adresse , 19 , 13)
                             Smtp_s31_empfaenger_mail_adresse = S + Smtp_s31_empfaenger_mail_adresse
                             Ee_s31_empfaenger_email_adresse = Smtp_s31_empfaenger_mail_adresse
               'schreibe Zeichen 19-31 von Ee_s31_empfaenger_email_adresse, Emailadresse muss von < > eingerahmt sein
               Case "{24}" :
                             S = Incoming_data
                             Smtp_s31_empfaenger_mail_adresse = Left(smtp_s31_empfaenger_mail_adresse , 18)
                             Smtp_s31_empfaenger_mail_adresse = Smtp_s31_empfaenger_mail_adresse + S
                             Ee_s31_empfaenger_email_adresse = Smtp_s31_empfaenger_mail_adresse
               'Schreibe Benutzerkennung, darf maximal 18 zeichen lang sein
               Case "{25}" :
                             S = Incoming_data
                             Smtp_s47_benutzerkennung = S + "{013}{010}"
                             Ee_s47_benutzerkennung = Smtp_s47_benutzerkennung
               'Schreibe Passwort, darf maximal 18 Zeichen lang sein
               Case "{26}" :
                             S = Incoming_data
                             Smtp_s31_passwort = S + "{013}{010}"
                             Ee_s31_passwort = Smtp_s31_passwort
               'Schreibe Anlagenleistung
               Case "{27}" :
                             Fs_anlagenleistung = Val(incoming_data)
                             Ee_fs_anlagenleistung = Fs_anlagenleistung
               'Schreibe Zhlerstand
               Case "{28}" :
                             Fs_pulszahlges = Val(incoming_data)
                             Ee_fs_pulszahlges = Fs_pulszahlges
               'Lsche alle Freesol-Daten im Eeprom
               Case "{29}" :
                             Fs_eeram_loeschen
               'Testmail sofort senden
               Case "{30}" :
                             Fs_mail_datum = Date$
                             Fs_mail_energie = 88888
                             Fs_mail_energienorm = Fs_mail_energie / Fs_anlagenleistung
                             Smtp_mail_versand_in = 1
                             #if System_message > 0
                               Print "Mail_versand_in = " ; Smtp_mail_versand_in ; " Minuten "
                             #endifn
                'Schreibe Pulsfaktor
               Case "{31}" :
                             Fs_pulsfaktor = Val(incoming_data)
                             Ee_fs_pulsfaktor = Fs_pulsfaktor
               Case "{99}" : Goto 0
         End Select
         Incoming_data = ""
     End If
End Sub

Sub Spliter(byval Trenner As String)
Local B_b As Byte , B_c As Byte
       Replacechars Incoming_data , Trenner , " "
       B_b = Split(incoming_data , Rs232_c(1) , " ")
       For B_c = 1 To B_b
          Rs232_c(b_c) = Trim(rs232_c(b_c))
       Next
End Sub

'*******************************************************************************
'  Interrupt Serielle
'*******************************************************************************
Sub Serial0charmatch()
   Input Incoming_data Noecho
End Sub